Subject: Re: [PATCH v2 0/2] clone: simplify progress message

From: Michael J Gruber <[email-masked]>
Date: Tue, 11 May 2010 09:27:07 +0200

Pete Harlan venit, vidit, dixit 11.05.2010 01:22:
> On 05/10/2010 03:31 AM, Michael J Gruber wrote:
>> Jeff King venit, vidit, dixit 10.05.2010 07:47:
>>> On Sun, May 09, 2010 at 01:09:14PM -0700, Pete Harlan wrote:
>>>
>>>>> I guess it comes down to how much detail we want to show.
>>>>
>>>> For me it isn't only a matter of detail; I find "Cloning into 
>>>> bar/.git" misleading, since bar is getting more than a .git 
>>>> directory.
>>>
>>> Yeah, I can buy that line of reasoning. Junio's nitpick aside, I 
>>> think most users perceive the clone process as creating the whole 
>>> "bar" directory.
>>>
>>>> Thank you for looking at this.  I agree with you, and have added 
>>>> a second patch that implements that.
>>>
>>> These patches look good to me. I agree with Junio about just 
>>> squashing them.
>>>
>>> -Peff
>>
>> Back from a conference, I'm being late for the party (Which way
>> round is better? ;) ).
>>
>> But I still want to suggest not sacrificing correctness for "user's 
>> expectations" and rather trying to do combine them. So how about 
>> saying
>>
>> Cloning into $GIT_DIR... Checking out branch $branch in $WORK_DIR...
>>
>> where the latter happens for non-bare repos only, of course, and 
>> incidently confirms the use of "-b" or of the default.
>>
>> Michael
> 
> Thanks for looking at this.  The patch you posted reports, e.g.:
> 
>   % git clone foo bar
>   Cloning into /tmp/git/bar/.git...
>   done.
>   Checking out branch master into worktree bar.
>   %
> 
> I'd like to see "worktree" either omitted or replaced with "working
> directory".  Git works on trees, but "working directory" is a term
> ordinary users understand and "bar" is a directory being populated
> with files so there's nothing wrong with the user thinking of it that
> way.

"working tree" (short: worktree) is the Git term, core.worktree the name
of the config variable, GIT_WORK_TREE the name of the environment
variable for the directory in which a tree is checked out.

"working directory" is the name of the directory which you are in (i.e.
$(pwd)).

While, technically, the wd is the wt during the check out, using wd
would introduce users to the wrong terminology.

> But on a different note, I think we don't have to be so verbose.  If
> the user asks for details with -v then be as chatty as we want, but
> for the most part operations that succeed should do so quietly.

In fact, we introduced that message not that long ago because until
then, only init's message would be displayed to the user ("Initializing
empty..."), which was highly confusing.

The consensus back then was, without -v nor -q, to have everyday
commands be silent on successful operation, and "infrequent" commands
report progress.

Cheers,
Michael